
	section	.text
	align	1

	;------------------------------------------------------
	global _eol, _blank, _print_byte, _print_word

_print_word
	pshm e
	ted
	xgab
	tde
	bsr  _print_byte
	pulm e
_print_byte
	ted
	pshm d
	lsrb
	lsrb
	lsrb
	lsrb
	bsr  pb1
	pulm d
pb1
	andb # 0Fh
	addb # '0'
	cmpb # '9'
	bls  putit
	addb # 7
putit
	clra
	tde
	jmp _putchar

_eol
	ldab # 0Ah
	bra putit

_blank
	ldab # 20h
	bra putit



	global _print_string
_print_string

	pshm e,z        ; promptly stack the argument also
	tsz             ; now at 2,z
	bra  L31
L30
	aix  #+1        ; bump byte ptr
	stx  2,z
	bsr  putit
L31
	ldx  2,z        ; byte ptr
	ldab 0,x        ; next byte
	bne  L30        ; until EOS

	pulm e,z        ; E pulled to manage the stack
	rts

	;------------------------------------------------------
	global _strlen
_strlen

	xgex       ; arg1 in X
	clre       ; index from 0
	ldab e,x
	beq  L2
L1
	adde #1    ; next
	ldab e,x
	bne	 L1    ; loop until x[e] = \0
L2
	ted
	rts

	;------------------------------------------------------
	;  difference is correct only for 7-bit strings, BEWARE
	global _strcmp

	section	.inthand ; nano-optimisation
	align	1

_strcmp

	xgex       ; arg1 in X
	xgdy       ; arg2 in Y
	lde  #-1   ; start with index 0
L3
	adde #1    ; preincrement to next
	ldab e,x
	beq  L4    ; end of first string
	subb e,y
	beq  L3    ; loop while same

	sxt        ; sign extend difference
	rts
L4
	subb e,y   ; 0 if end of second string too
	sxt
	rts	

	section	.text ; back to normal
	align	1

	;------------------------------------------------------
	global _strcpyx
_strcpyx

	xgex       ; arg1 in X, dst
	xgdy       ; arg2 in Y, src
	clre       ; index from 0
	bra  L6
L5
	adde #1    ; next
L6
	ldab e,y
	stab e,x
	bne  L5    ; not yet at end

	xgdx	   ; dst[] to D
	ade        ; index += dst[]
	ted        ; return pointer at \0 in dst[]
	rts

	;------------------------------------------------------
	global _strncmp
_strncmp

	pshm z
	tsz        ; arg3 in 6,z, maxlen
	xgex       ; arg1 in X
	xgdy       ; arg2 in Y
	ldd  6,z   ; maxlen 0 ?!
	beq  L9    ; odd, but return the 0 in D
	clre       ; index from 0
L7
	ldaa e,x
	ldab e,y
	sba        ; A -= B
	bne  L8    ; go if not same
	tstb       ; end of strings ?
	beq  L9    ; go if yes, D is 0
	adde #1    ; next
	cpe  6,z
	bne  L7    ; thru maxlen characters ? A still 0
L8
	tab        ; difference in 8 bits
	sxt        ; sign extend B to D
L9
	pulm z
	rts

	;------------------------------------------------------
	global _substrcasecmp ; int substrcasecmp("zaPpa" + 1, "APP");

_substrcasecmp
	xgex   ; unknown bytes, unknown case
	xgdy   ; pattern, already in upper case, \0 terminated

	clre   ; index 0...

casecmp_0
	ldaa e,y
	beq  casecmp_out  ; A \0, compare ok
	ldab e,x
	adde # 1
	cmpb # 'a'
	blo  casecmp_1
	cmpb # 'z'
	bhi  casecmp_1
	eorb # 20h
casecmp_1
	sba               ; A nonzero if not ok
	beq  casecmp_0    ; so far ok

casecmp_out
	tab
	sxt
	rts

	;------------------------------------------------------
	global _strncpyx
_strncpyx

	tsx        ; arg3 in 4,x, buflen
	ldx  4,x
	xgex       ; arg1 in X, dst, buflen in E
	xgdy       ; arg2 in Y, src

	sube #1    ; maxlen - 1 characters and trailing zeroes
	bcs  L21   ; maxlen was 0 ?! cannot store anything
	beq  L20_5 ; maxlen was 1 ?! only the \0
L19
	ldab 0,y
	beq  L20
	aiy  #+1   ; only if not at \0 of src
L20
	stab 0,x
	aix  #+1
	sube #1
	bne  L19
L20_5
	clr  0,x   ; terminate always
L21
	xgdx       ; return pointer to \0 in dst
	rts

	;------------------------------------------------------
	global _index
_index

	xgex       ; arg1 in X
	           ; arg2 in B already (D)
L90
	ldaa 0,x
	cba        ; match ?
	beq  L91   ; found it (could be \0)
	aix  #+1   ; point next
	tsta       ; was \0 ?
	bne  L90   ; while not
	ldx  # 0   ; NULL
L91
	xgdx       ; return x
	rts

	;------------------------------------------------------
	global _strend
_strend

	xgex       ; arg1 in X
	bra  L99   ; start from bottom
L98
	aix  #+1   ; point next
L99
	tst  0,x   ; \0 ?
	bne  L98   ; until
	xgdx       ; return that
	rts

	;------------------------------------------------------
	global _memchr

_memchr
	tsy           ; arg3 in 4,y
	tstw 4,y      ; zero length ?
	beq  memchr_2 ; yes.
	xgex          ; arg1 in X
memchr_1
	cmpb 0,x      ; arg2 in B already (D)
	beq  memchr_3 ; found it
	aix  #+1      ; point next
	decw 4,y
	bne  memchr_1 ; scan length bytes
memchr_2
	ldx  # 0      ; NULL
memchr_3
	xgdx          ; return X
	rts

	;------------------------------------------------------
	global _isdigit
_isdigit

	ted

	cmpb # '0'
	bcs  isdigit_no
	cmpb # '9' + 1
	bcc  isdigit_no

	ldd  #1    ; return 1, is digit
	rts

isdigit_no
	clrd       ; return 0, not digit
	rts

	;------------------------------------------------------
	global _isalnum
_isalnum

	ted

	cmpb # '0'
	bcs  isalnum_no
	cmpb # '9' + 1
	bcs  isalnum

	cmpb # 'A'
	bcs  isalnum_no
	cmpb # 'Z' + 1
	bcs  isalnum

	cmpb # 'a'
	bcs  isalnum_no
	cmpb # 'z' + 1
	bcc  isalnum_no

isalnum
	ldd  # 1
	rts
isalnum_no
	clrd
	rts

	;------------------------------------------------------
	global _isspace
_isspace

	ted

	; 8-13 is bs ht lf vt ff cr. define those as "space" too.

	cmpb # ' '
	beq  isspace
	cmpb # 13
	bhi  isspace_not
	cmpb # 8
	blo  isspace_not
isspace
	ldd  #1    ; return TRUE
	rts

isspace_not
	clrd       ; return FALSE
	rts

	;------------------------------------------------------
	global _toupper
_toupper

	ted        ; assume as-is
	clra       ; paranoia

toupper_B                      ; can touch only B

	cmpb #61h  ; 'a'
	bcs  L11
	cmpb #7Bh  ; 'z' + 1
	bcc  L11

	eorb #20h  ; flip case
L11
	rts

	;------------------------------------------------------
	global _tolower
_tolower

	ted        ; assume as-is
	clra       ; paranoia

tolower_B                      ; can touch only B

	cmpb #41h  ; 'A'
	bcs  L12
	cmpb #5Bh  ; 'Z' + 1
	bcc  L12

	eorb #20h  ; flip case
L12
	rts

	;------------------------------------------------------
	global _strupper
_strupper

	xgex       ; arg1 in X
	clre       ; index from 0
	bra  L14   ; bottom of loop
L13
	lbsr toupper_B        ; can touch only B
	stab e,x
	adde #1    ; next
L14
	ldab e,x
	bne  L13   ; not yet at end

	rts

	;------------------------------------------------------
	global _strlower
_strlower

	xgex       ; arg1 in X
	clre       ; index from 0
	bra  L16   ; bottom of loop
L15
	lbsr tolower_B        ; can touch only B
	stab e,x
	adde #1    ; next
L16
	ldab e,x
	bne  L15   ; not yet at end

	rts

	;------------------------------------------------------
	global _strcasecmp
_strcasecmp

	xgex       ; arg1 in X
	xgdy       ; arg2 in Y
	clre       ; index from 0
L17
	ldab e,x
	lbsr toupper_B               ; can touch only B
	tba             ; remember
	ldab e,y
	lbsr toupper_B               ; can touch only B
	sba             ; A -= B
	bne  L18        ; difference in A
	adde #1         ; next
	tstb            ; end of string ?
	bne  L17        ; if yes, A still zero and B too

	rts
L18
	tab        ; difference in 8 bits
	sxt        ; sign extend B to D XXX sort of national strings fails
	rts	

	;------------------------------------------------------
	global _bzero
_bzero

	xgex       ; arg1 in X
	tde        ; arg2 in E
	clrb       ; the zero
	bra L23    ; start from bottom of loop
L22
	stab e,x
L23
	sube #1    ; zero backwards, from end to 0
	bcc  L22

	rts

	;------------------------------------------------------
	global _bcmp
_bcmp

	tsx        ; arg3 in 4,x, byte count
	ldx  4,x
	xgex       ; arg1 in X, first ptr. byte count in E
	xgdy       ; arg2 in Y, second ptr
	clrd       ; result MSByte always clear
	bra  L25   ; start from bottom of loop
L24
	ldab e,x
	subb e,y
	bne  L26   ; difference in B, return value nonzero
L25
	sube #1    ; compare backwards, from end to [0]
	bcc  L24   ; D still 0 when finised
L26
	rts

	;------------------------------------------------------
	global _bcopy
_bcopy

	pshm z
	tsz
	ldx  6,z   ; arg3 in 6,z, byte count in X
	beq  L29   ; count 0, do nothing

	; if src < dst, overlapping copy forward can fail
	; bcopy(0, 1, 2): [0] -> [1], [1] -> [2] oh no
	; but [1] -> [2], [0] -> [1] is ok

	pshm e
	sde        ; src -= dst, carry if src < dst
	pulm e
	xgex       ; arg1 in X, src.  byte count in E
	xgdy       ; arg2 in Y, dst
	bcs  L28   ; which way to handle overlap ? ccr still valid from sde

	clre       ; index from 0
L27
	ldab e,x   ; src[i]      copy forwards
	stab e,y   ; dst[i]
	adde #1    ; i++
	cpe  6,z   ; i == cc ?
	bne  L27   ; more, if not

	bra  L29   ; outta here
L28
	sube #1    ; --i         copy backwards
	ldab e,x   ; src[i]
	stab e,y   ; dst[i]
	tste       ; i == 0 ?
	bne  L28   ; more, if not
L29
	pulm z
	rts

	;------------------------------------------------------
	end
